Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traadv_cen2.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 2023)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 2024)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                     ***  MODULE  traadv_cen2  ***
-   !! Ocean active tracers:  horizontal & vertical advective trend
+   !! Ocean  tracers:  horizontal & vertical advective trend
    !!======================================================================
    !! History :  8.2  ! 2001-08  (G. Madec, E. Durand)  trahad+trazad=traadv 
@@ -11,4 +11,5 @@
    !!             -   ! 2006-07  (G. madec)  add ups_orca_set routine
    !!            3.2  ! 2009-07  (G. Madec) add avmb, avtb in restart for cen2 advection
+   !!            3.3  ! 2010-05  (C. Ethe, G. Madec)  merge TRC-TRA + switch from velocity to transport
    !!----------------------------------------------------------------------
 
@@ -19,21 +20,14 @@
    !!                  area (set for orca 2 and 4 only)
    !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and active tracers
+   USE oce, ONLY: tsn  ! now ocean temperature and salinity
    USE dom_oce         ! ocean space and time domain
-   USE sbc_oce         ! surface boundary condition: ocean
-   USE dynspg_oce      ! choice/control of key cpp for surface pressure gradient
-   USE trdmod_oce      ! ocean variables trends
    USE eosbn2          ! equation of state
-   USE trdmod          ! ocean active tracers trends 
+   USE trdmod_oce      ! tracers trends
+   USE trdtra          ! tracers trends
    USE closea          ! closed sea
-   USE trabbl          ! advective term in the BBL
-   USE sbcmod          ! surface Boundary Condition
    USE sbcrnf          ! river runoffs
    USE in_out_manager  ! I/O manager
    USE iom             ! IOM library
-   USE lib_mpp
-   USE lbclnk          ! ocean lateral boundary condition (or mpp link)
    USE diaptr          ! poleward transport diagnostics
-   USE prtctl          ! Print control
    USE zdf_oce         ! ocean vertical physics
    USE restart         ! ocean restart
@@ -45,9 +39,8 @@
    PUBLIC   ups_orca_set    ! routine used by traadv_cen2_jki.F90
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   upsmsk    !: mixed upstream/centered scheme near some straits 
+   LOGICAL  :: l_trd       ! flag to compute trends
+
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) :: upsmsk    !: mixed upstream/centered scheme near some straits 
    !                                                   !  and in closed seas (orca 2 and 4 configurations)
-
-   REAL(wp), DIMENSION(jpi,jpj) ::   btr2   ! inverse of T-point surface [1/(e1t*e2t)]
-
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -61,5 +54,6 @@
 CONTAINS
 
-   SUBROUTINE tra_adv_cen2( kt, pun, pvn, pwn )
+   SUBROUTINE tra_adv_cen2( kt   , cdtype, pun  , pvn, pwn, &
+      &                     ptrab, ptran , ptraa, kjpt   ) 
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE tra_adv_cen2  ***
@@ -77,9 +71,9 @@
       !!         Part I : horizontal advection
       !!       * centered flux:
-      !!               zcenu = e2u*e3u  un  mi(tn)
-      !!               zcenv = e1v*e3v  vn  mj(tn)
+      !!               zcenu = e2u*e3u  un  mi(ptran)
+      !!               zcenv = e1v*e3v  vn  mj(ptran)
       !!       * upstream flux:
-      !!               zupsu = e2u*e3u  un  (tb(i) or tb(i-1) ) [un>0 or <0]
-      !!               zupsv = e1v*e3v  vn  (tb(j) or tb(j-1) ) [vn>0 or <0]
+      !!               zupsu = e2u*e3u  un  (ptrab(i) or ptrab(i-1) ) [un>0 or <0]
+      !!               zupsv = e1v*e3v  vn  (ptrab(j) or ptrab(j-1) ) [vn>0 or <0]
       !!       * mixed upstream / centered horizontal advection scheme
       !!               zcofi = max(zind(i+1), zind(i))
@@ -88,61 +82,55 @@
       !!               zwy = zcofj * zupsv + (1-zcofj) * zcenv
       !!       * horizontal advective trend (divergence of the fluxes)
-      !!               zta = 1/(e1t*e2t*e3t) { di-1[zwx] + dj-1[zwy] }
+      !!               ztra = 1/(e1t*e2t*e3t) { di-1[zwx] + dj-1[zwy] }
       !!       * Add this trend now to the general trend of tracer (ta,sa):
-      !!              (ta,sa) = (ta,sa) + ( zta , zsa )
+      !!               ptraa = ptraa + ztra
       !!       * trend diagnostic ('key_trdtra' defined): the trend is
       !!      saved for diagnostics. The trends saved is expressed as
       !!      Uh.gradh(T), i.e.
-      !!                     save trend = zta + tn divn
-      !!         In addition, the advective trend in the two horizontal direc-
-      !!      tion is also re-computed as Uh gradh(T). Indeed hadt+tn divn is
-      !!      equal to (in s-coordinates, and similarly in z-coord.):
-      !!         zta+tn*divn=1/(e1t*e2t*e3t) { mi-1( e2u*e3u  un  di[tn] )
-      !!                                      +mj-1( e1v*e3v  vn  mj[tn] )  }
-      !!         NB:in z-coordinate - full step (ln_zco=T) e3u=e3v=e3t, so
-      !!      they vanish from the expression of the flux and divergence.
+      !!                     save trend = ztra + ptran divn
       !!
       !!         Part II : vertical advection
       !!      For temperature (idem for salinity) the advective trend is com-
       !!      puted as follows :
-      !!            zta = 1/e3t dk+1[ zwz ]
+      !!            ztra = 1/e3t dk+1[ zwz ]
       !!      where the vertical advective flux, zwz, is given by :
       !!            zwz = zcofk * zupst + (1-zcofk) * zcent
       !!      with
-      !!        zupsv = upstream flux = wn * (tb(k) or tb(k-1) ) [wn>0 or <0]
+      !!        zupsv = upstream flux = wn * (ptrab(k) or ptrab(k-1) ) [wn>0 or <0]
       !!        zcenu = centered flux = wn * mk(tn)
       !!         The surface boundary condition is :
       !!      variable volume (lk_vvl = T) : zero advective flux
-      !!      lin. free-surf  (lk_vvl = F) : wn(:,:,1) * tn(:,:,1)
+      !!      lin. free-surf  (lk_vvl = F) : wn(:,:,1) * ptran(:,:,1)
       !!         Add this trend now to the general trend of tracer (ta,sa):
-      !!            (ta,sa) = (ta,sa) + ( zta , zsa )
+      !!             ptraa = ptraa + ztra
       !!         Trend diagnostic ('key_trdtra' defined): the trend is
       !!      saved for diagnostics. The trends saved is expressed as :
-      !!             save trend =  w.gradz(T) = zta - tn divn.
-      !!
-      !! ** Action :  - update (ta,sa) with the now advective tracer trends
-      !!              - save trends in (ztrdt,ztrds) ('key_trdtra')
-      !!----------------------------------------------------------------------
-      USE oce, ONLY :   zwx => ua   ! use ua as workspace
-      USE oce, ONLY :   zwy => va   ! use va as workspace
-      !!
-      INTEGER , INTENT(in)                         ::   kt    ! ocean time-step index
-      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pun   ! ocean velocity u-component
-      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pvn   ! ocean velocity v-component
-      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pwn   ! ocean velocity w-component
-      !!
-      INTEGER  ::   ji, jj, jk                       ! dummy loop indices
-      REAL(wp) ::   zbtr, zhw, ze3tr                 ! temporary scalars
-      REAL(wp) ::   zfp_ui, zfp_vj, zfp_w , zfui     !    -         -
-      REAL(wp) ::   zfm_ui, zfm_vj, zfm_w , zfvj     !    -         -
+      !!             save trend =  w.gradz(T) = ztra - ptran divn.
+      !!
+      !! ** Action :  - update ptraa  with the now advective tracer trends
+      !!              - save trends if needed
+      !!----------------------------------------------------------------------
+      !!* Module used
+      USE oce         , zwx => ua   ! use ua as workspace
+      USE oce         , zwy => va   ! use va as workspace
+      !!* Arguments
+      INTEGER         , INTENT(in   )                               ::   kt              ! ocean time-step index
+      CHARACTER(len=3), INTENT(in   )                               ::   cdtype          ! =TRA or TRC (tracer indicator)
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,jpk)       ::   pun, pvn, pwn   ! 3 ocean velocity components
+      INTEGER         , INTENT(in   )                               ::   kjpt            ! number of tracers
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptrab, ptran        ! before and now tracer fields
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptraa           ! tracer trend 
+      !!* Local declarations
+      INTEGER  ::   ji, jj, jk, jn                   ! dummy loop indices
+      REAL(wp) ::   zbtr, ztra                       ! temporary scalars
+      REAL(wp) ::   zfp_ui, zfp_vj, zfp_w            !    -         -
+      REAL(wp) ::   zfm_ui, zfm_vj, zfm_w            !    -         -
       REAL(wp) ::   zcofi , zcofj , zcofk            !    -         -
-      REAL(wp) ::   zupsut, zupsus, zcenut, zcenus   !    -         -
-      REAL(wp) ::   zupsvt, zupsvs, zcenvt, zcenvs   !    -         -
-      REAL(wp) ::   zupst , zupss , zcent , zcens    !    -         -
-      REAL(wp) ::   z_hdivn_x, z_hdivn_y, z_hdivn    !    -         -
+      REAL(wp) ::   zupsut, zcenut                   !    -         -
+      REAL(wp) ::   zupsvt, zcenvt                   !    -         -
+      REAL(wp) ::   zupst , zcent                    !    -         -
       REAL(wp) ::   zice                             !    -         -
       REAL(wp), DIMENSION(jpi,jpj)     ::   ztfreez            ! 2D workspace
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwz, ztrdt, zind   ! 3D workspace
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zww, ztrds         !  "      "
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwz, zind   ! 3D workspace 
       !!----------------------------------------------------------------------
 
@@ -157,7 +145,4 @@
          IF( cp_cfg == "orca" )   CALL ups_orca_set      ! set mixed Upstream/centered scheme near some straits
          !                                               ! and in closed seas (orca2 and orca4 only)
-         !   
-         btr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )        ! inverse of T-point surface
-         !
          IF( jp_cfg == 2 .AND. .NOT. ln_rstart ) THEN    ! Increase the background in the surface layers
             avmb(1) = 10.  * avmb(1)      ;      avtb(1) = 10.  * avtb(1)
@@ -166,16 +151,19 @@
             avmb(4) =  2.5 * avmb(4)      ;      avtb(4) =  2.5 * avtb(4)
          ENDIF
+         !
+         l_trd = .FALSE.
+         IF( ( cdtype == 'TRA' .AND. l_trdtra ) .OR. ( cdtype == 'TRC' .AND. l_trdtrc ) ) l_trd = .TRUE.
       ENDIF
-
+      !
       ! Upstream / centered scheme indicator
       ! ------------------------------------
 !!gm  not strickly exact : the freezing point should be computed at each ocean levels...
 !!gm  not a big deal since cen2 is no more used in global ice-ocean simulations
-      ztfreez(:,:) = tfreez( sn(:,:,1) )
+      ztfreez(:,:) = tfreez( tsn(:,:,1,jp_sal) )
       DO jk = 1, jpk
          DO jj = 1, jpj
             DO ji = 1, jpi
                !                                        ! below ice covered area (if tn < "freezing"+0.1 )
-               IF( tn(ji,jj,jk) <= ztfreez(ji,jj) + 0.1 ) THEN   ;   zice = 1.e0
+               IF( tsn(ji,jj,jk,jp_tem) <= ztfreez(ji,jj) + 0.1 ) THEN   ;   zice = 1.e0
                ELSE                                              ;   zice = 0.e0
                ENDIF
@@ -189,167 +177,98 @@
       END DO
 
-      ! I. Horizontal advection
-      !    ====================
-      !
-      DO jk = 1, jpkm1
-         !                        ! Second order centered tracer flux at u- and v-points
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               ! upstream indicator
-               zcofi = MAX( zind(ji+1,jj,jk), zind(ji,jj,jk) )
-               zcofj = MAX( zind(ji,jj+1,jk), zind(ji,jj,jk) )
-               ! volume fluxes * 1/2
-               zfui = 0.5 * e2u(ji,jj) * fse3u(ji,jj,jk) * pun(ji,jj,jk)
-               zfvj = 0.5 * e1v(ji,jj) * fse3v(ji,jj,jk) * pvn(ji,jj,jk)
+      DO jn = 1, kjpt
+         !
+         ! I. Horizontal advection
+         !    ====================
+         !
+         DO jk = 1, jpkm1
+            !                        ! Second order centered tracer flux at u- and v-points
+            DO jj = 1, jpjm1
                !
-               ! upstream scheme
-               zfp_ui = zfui + ABS( zfui )
-               zfp_vj = zfvj + ABS( zfvj )
-               zfm_ui = zfui - ABS( zfui )
-               zfm_vj = zfvj - ABS( zfvj )
-               zupsut = zfp_ui * tb(ji,jj,jk) + zfm_ui * tb(ji+1,jj  ,jk)
-               zupsvt = zfp_vj * tb(ji,jj,jk) + zfm_vj * tb(ji  ,jj+1,jk)
-               zupsus = zfp_ui * sb(ji,jj,jk) + zfm_ui * sb(ji+1,jj  ,jk)
-               zupsvs = zfp_vj * sb(ji,jj,jk) + zfm_vj * sb(ji  ,jj+1,jk)
-               ! centered scheme
-               zcenut = zfui * ( tn(ji,jj,jk) + tn(ji+1,jj  ,jk) )
-               zcenvt = zfvj * ( tn(ji,jj,jk) + tn(ji  ,jj+1,jk) )
-               zcenus = zfui * ( sn(ji,jj,jk) + sn(ji+1,jj  ,jk) )
-               zcenvs = zfvj * ( sn(ji,jj,jk) + sn(ji  ,jj+1,jk) )
-               ! mixed centered / upstream scheme
-               zwx(ji,jj,jk) = zcofi * zupsut + (1.-zcofi) * zcenut
-               zwy(ji,jj,jk) = zcofj * zupsvt + (1.-zcofj) * zcenvt
-               zww(ji,jj,jk) = zcofi * zupsus + (1.-zcofi) * zcenus
-               zwz(ji,jj,jk) = zcofj * zupsvs + (1.-zcofj) * zcenvs
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  ! upstream indicator
+                  zcofi = MAX( zind(ji+1,jj,jk), zind(ji,jj,jk) )
+                  zcofj = MAX( zind(ji,jj+1,jk), zind(ji,jj,jk) )
+                  !
+                  ! upstream scheme
+                  zfp_ui = pun(ji,jj,jk) + ABS( pun(ji,jj,jk) )
+                  zfm_ui = pun(ji,jj,jk) - ABS( pun(ji,jj,jk) )
+                  zfp_vj = pvn(ji,jj,jk) + ABS( pvn(ji,jj,jk) )
+                  zfm_vj = pvn(ji,jj,jk) - ABS( pvn(ji,jj,jk) )
+                  zupsut = zfp_ui * ptrab(ji,jj,jk,jn) + zfm_ui * ptrab(ji+1,jj  ,jk,jn)
+                  zupsvt = zfp_vj * ptrab(ji,jj,jk,jn) + zfm_vj * ptrab(ji  ,jj+1,jk,jn)
+                  ! centered scheme
+                  zcenut = pun(ji,jj,jk) * ( ptran(ji,jj,jk,jn) + ptran(ji+1,jj  ,jk,jn) )
+                  zcenvt = pvn(ji,jj,jk) * ( ptran(ji,jj,jk,jn) + ptran(ji  ,jj+1,jk,jn) )
+                  ! mixed centered / upstream scheme
+                  zwx(ji,jj,jk) = 0.5 * ( zcofi * zupsut + (1.-zcofi) * zcenut )
+                  zwy(ji,jj,jk) = 0.5 * ( zcofj * zupsvt + (1.-zcofj) * zcenvt )
+               END DO
             END DO
          END DO
-         !                        ! Tracer flux divergence at t-point added to the general trend
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zbtr = btr2(ji,jj) / fse3t(ji,jj,jk)
-               !
-               ta(ji,jj,jk) = ta(ji,jj,jk) - zbtr * (  zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk)  &
-                  &                                  + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk)  )
-               sa(ji,jj,jk) = sa(ji,jj,jk) - zbtr * (  zww(ji,jj,jk) - zww(ji-1,jj  ,jk)  &
-                  &                                  + zwz(ji,jj,jk) - zwz(ji  ,jj-1,jk)  )
+
+         ! II. Vertical advection
+         !     ==================
+         !
+         !                                                ! Vertical advective fluxes
+         zwz(:,:,jpk) = 0.e0                                   ! Bottom  value : flux set to zero
+         !                                                     ! Surface value : 
+         IF( lk_vvl ) THEN   ;   zwz(:,:, 1 ) = 0.e0                         ! volume variable
+         ELSE                ;   zwz(:,:, 1 ) = pwn(:,:,1) * ptran(:,:,1,jn)   ! linear free surface 
+         ENDIF
+         !
+         DO jk = 2, jpk              ! Second order centered tracer flux at w-point
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  ! upstream indicator
+                  zcofk = MAX( zind(ji,jj,jk-1), zind(ji,jj,jk) ) 
+                  ! mixed centered / upstream scheme
+                  zfp_w = pwn(ji,jj,jk) + ABS( pwn(ji,jj,jk) )
+                  zfm_w = pwn(ji,jj,jk) - ABS( pwn(ji,jj,jk) )
+                  zupst = zfp_w * ptrab(ji,jj,jk,jn) + zfm_w * ptrab(ji,jj,jk-1,jn)
+                  ! centered scheme
+                  zcent = pwn(ji,jj,jk) * ( ptran(ji,jj,jk,jn) + ptran(ji,jj,jk-1,jn) )
+                  ! mixed centered / upstream scheme
+                  zwz(ji,jj,jk) = 0.5 * ( zcofk * zupst + (1.-zcofk) * zcent )
+               END DO
             END DO
          END DO
-      END DO
-
-
-      IF( l_trdtra ) THEN      ! Save the i- and j-advective trends for diagnostic (U.gradz(T) trends)
-         !
+
+         ! II. Divergence of advective fluxes
+         ! ----------------------------------
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  !-- Compute zonal divergence by splitting hdivn (see divcur.F90)
-                  !   N.B. This computation is not valid with OBC, BDY, cla, eiv, advective bbl 
-                  zbtr      = btr2(ji,jj) / fse3t(ji,jj,jk)
-                  z_hdivn_x = (  e2u(ji  ,jj) * fse3u(ji  ,jj,jk) * pun(ji  ,jj,jk)          &
-                     &         - e2u(ji-1,jj) * fse3u(ji-1,jj,jk) * pun(ji-1,jj,jk) ) * zbtr
-                  !
-                  ztrdt(ji,jj,jk) = - zbtr * ( zwx(ji,jj,jk) - zwx(ji-1,jj,jk) ) + tn(ji,jj,jk) * z_hdivn_x
-                  ztrds(ji,jj,jk) = - zbtr * ( zww(ji,jj,jk) - zww(ji-1,jj,jk) ) + sn(ji,jj,jk) * z_hdivn_x
+                  zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) *  fse3t(ji,jj,jk) )
+                  ! advective trends
+                  ztra = - zbtr * (  zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk  )   &
+                  &                + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk  )   &
+                  &                + zwz(ji,jj,jk) - zwz(ji  ,jj  ,jk+1)  )
+                  ! advective trends added to the general tracer trends
+                  ptraa(ji,jj,jk,jn) = ptraa(ji,jj,jk,jn) + ztra
                END DO
             END DO
          END DO
-         CALL trd_mod(ztrdt, ztrds, jptra_trd_xad, 'TRA', kt)
-         !
-         DO jk = 1, jpkm1           ! T/S MERIDIONAL advection trends
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zbtr      = btr2(ji,jj) / fse3t(ji,jj,jk)
-                  z_hdivn_y = (  e1v(ji,  jj) * fse3v(ji,jj  ,jk) * pvn(ji,jj  ,jk)          &
-                     &         - e1v(ji,jj-1) * fse3v(ji,jj-1,jk) * pvn(ji,jj-1,jk) ) * zbtr
-                  !
-                  ztrdt(ji,jj,jk) = - zbtr * ( zwy(ji,jj,jk) - zwy(ji,jj-1,jk) ) + tn(ji,jj,jk) * z_hdivn_y          
-                  ztrds(ji,jj,jk) = - zbtr * ( zwz(ji,jj,jk) - zwz(ji,jj-1,jk) ) + sn(ji,jj,jk) * z_hdivn_y
-               END DO
-            END DO
-         END DO
-         CALL trd_mod(ztrdt, ztrds, jptra_trd_yad, 'TRA', kt)
-         !
-         ztrdt(:,:,:) = ta(:,:,:)   ;   ztrds(:,:,:) = sa(:,:,:)       ! Save the horizontal up-to-date ta/sa trends
-         !
-      ENDIF
-
-      IF( ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN      ! "zonal" mean advective heat and salt transport 
-         pht_adv(:) = ptr_vj( zwy(:,:,:) )
-         pst_adv(:) = ptr_vj( zwz(:,:,:) )
-      ENDIF
-
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' cen2 had  - Ta: ', mask1=tmask, &
-         &                       tab3d_2=sa, clinfo2=            ' Sa: ', mask2=tmask, clinfo3='tra' )
-
-
-      ! II. Vertical advection
-      !     ==================
-      !
-      zwx(:,:,jpk) = 0.e0     ;    zwy(:,:,jpk) = 0.e0      ! Bottom value  : flux set to zero
-      !
-      IF( lk_vvl ) THEN                                     ! Surface value : zero in variable volume
-         zwx(:,:, 1 ) = 0.e0    ;    zwy(:,:, 1 ) = 0.e0
-      ELSE                                                  !               : linear free surface case
-         zwx(:,:, 1 ) = pwn(:,:,1) * tn(:,:,1)
-         zwy(:,:, 1 ) = pwn(:,:,1) * sn(:,:,1)
-      ENDIF
-      !
-      DO jk = 2, jpk              ! Second order centered tracer flux at w-point
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zcofk = MAX( zind(ji,jj,jk-1), zind(ji,jj,jk) )      ! upstream indicator
-               zhw = 0.5 * pwn(ji,jj,jk)                            ! velocity * 1/2
-               !
-               zfp_w = zhw + ABS( zhw )                             ! upstream scheme
-               zfm_w = zhw - ABS( zhw )
-               zupst = zfp_w * tb(ji,jj,jk) + zfm_w * tb(ji,jj,jk-1)
-               zupss = zfp_w * sb(ji,jj,jk) + zfm_w * sb(ji,jj,jk-1)
-               !
-               zcent = zhw * ( tn(ji,jj,jk) + tn(ji,jj,jk-1) )      ! centered scheme
-               zcens = zhw * ( sn(ji,jj,jk) + sn(ji,jj,jk-1) )
-               !
-               zwx(ji,jj,jk) = zcofk * zupst + (1.-zcofk) * zcent   ! mixed centered / upstream scheme
-               zwy(ji,jj,jk) = zcofk * zupss + (1.-zcofk) * zcens
-            END DO
-         END DO
-      END DO
-      !
-      DO jk = 1, jpkm1            ! divergence of Tracer flux added to the general trend
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               ze3tr = 1. / fse3t(ji,jj,jk)
-               ta(ji,jj,jk) =  ta(ji,jj,jk) - ze3tr * ( zwx(ji,jj,jk) - zwx(ji,jj,jk+1) )
-               sa(ji,jj,jk) =  sa(ji,jj,jk) - ze3tr * ( zwy(ji,jj,jk) - zwy(ji,jj,jk+1) )
-            END DO
-         END DO
-      END DO
-
-      IF( l_trdtra ) THEN      ! Save the vertical advective trends for diagnostic (W gradz(T) trends)
-         DO jk = 1, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zbtr      = btr2(ji,jj) / fse3t(ji,jj,jk)
-                  z_hdivn_x = e2u(ji,jj)*fse3u(ji,jj,jk)*pun(ji,jj,jk) - e2u(ji-1,jj)*fse3u(ji-1,jj,jk)*pun(ji-1,jj,jk)
-                  z_hdivn_y = e1v(ji,jj)*fse3v(ji,jj,jk)*pvn(ji,jj,jk) - e1v(ji,jj-1)*fse3v(ji,jj-1,jk)*pvn(ji,jj-1,jk)
-                  !
-                  z_hdivn   = (z_hdivn_x + z_hdivn_y) * zbtr
-                  ztrdt(ji,jj,jk) = ta(ji,jj,jk) - ztrdt(ji,jj,jk) - tn(ji,jj,jk) * z_hdivn 
-                  ztrds(ji,jj,jk) = sa(ji,jj,jk) - ztrds(ji,jj,jk) - sn(ji,jj,jk) * z_hdivn
-               END DO
-            END DO
-         END DO
-         CALL trd_mod(ztrdt, ztrds, jptra_trd_zad, 'TRA', kt)
-      ENDIF
-
-      ! write avmb, avtb in restart (traadv_cen2 requires a modified avmb, avtb that are
+
+         !                                 ! trend diagnostics (contribution of upstream fluxes)
+         IF( l_trd ) THEN
+            CALL trd_tra( kt, cdtype, jn, jptra_trd_xad, zwx, pun, ptran(:,:,:,jn) )
+            CALL trd_tra( kt, cdtype, jn, jptra_trd_yad, zwy, pvn, ptran(:,:,:,jn) )
+            CALL trd_tra( kt, cdtype, jn, jptra_trd_zad, zwz, pwn, ptran(:,:,:,jn) )
+         END IF
+         !                                 ! "Poleward" heat and salt transports (contribution of upstream fluxes)
+         IF( cdtype == 'TRA' .AND. ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN  
+           IF( jn == jp_tem )  pht_adv(:) = ptr_vj( zwy(:,:,:) )
+           IF( jn == jp_sal )  pst_adv(:) = ptr_vj( zwy(:,:,:) )
+         ENDIF
+         !
+      ENDDO
+
       ! ---------------------------  required in restart file to ensure restartability)
       ! avmb, avtb will be read in zdfini in restart case as they are used in zdftke, kpp etc...
-      IF( lrst_oce ) THEN
+      IF( lrst_oce .AND. cdtype == 'TRA' ) THEN
          CALL iom_rstput( kt, nitrst, numrow, 'avmb', avmb )
          CALL iom_rstput( kt, nitrst, numrow, 'avtb', avtb )
       ENDIF
-
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' cen2 zad  - Ta: ', mask1=tmask, &
-         &                       tab3d_2=sa, clinfo2=            ' Sa: ', mask2=tmask, clinfo3='tra' )
       !
    END SUBROUTINE tra_adv_cen2
